// == Dependencies ==
const mongoose = require('mongoose');
const Schema = mongoose.Schema;
const schema = new Schema({
  name: { type: String, unique: true },
  values: [String],
  group: { type: Schema.Types.ObjectId, ref: 'list_group' },
  archive: { type: Boolean, default: false },
}, {
  strict: true,
  safe: {
    j: 0,           // journals to wait for to complete
    w: 1,           // replications to wait for to complete
    wtimeout: 5000, // miliseconds after which a write times out
  },
});

module.exports = schema;
