const mongoose = require('mongoose');
const timestamps = require('mongoose-timestamp');
const Schema = mongoose.Schema;

const userSchema = new Schema({
  _id: { type: Schema.Types.ObjectId, required: true },
  access: { type: Boolean, required: true },
});

userSchema.plugin(timestamps);
const schema = new Schema({
  stepId: String,
  diagramId: { type: Schema.Types.ObjectId, required: true },
  bappId: { type: Schema.Types.ObjectId, required: true },
  users: { type: [userSchema], default: [] },
  byOmission: { type: Schema.Types.ObjectId, required: true },
}, {
  strict: true,
  safe: {
    j: 0,           // journals to wait for to complete
    w: 1,           // replications to wait for to complete
    wtimeout: 5000, // miliseconds after which a write times out
  },
});
schema.plugin(timestamps);

module.exports = schema;
