const f = require('./functions.js');
// const cache = require('apicache').options({ debug: true }).middleware;

module.exports = (app, protect) => {
  app.get('/catalogs/items', protect, f.getCatalogItemsPerPageHTTP);
  app.get('/catalogs/fetch', protect, f.fetchItemsByQuery);
  app.get('/g4/catalog/fetch/:catalogName', protect, f.fetchItemsByQuery);
  app.get('/catalogs', protect, f.getCatalogListHTTP);

  return (socket, io) => {
    socket.on('catalogs:show', f.getCatalogItem.bind({}, socket, io));
    socket.on('catalogs:list', f.getCatalogListWS.bind({}, socket, io));
    socket.on('catalogs:items', f.getCatalogItemsPerPageWS.bind({}, socket, io));
    socket.on('catalogs:delete', f.deleteCatalogWS.bind({}, socket, io));
  };
};
