'use strict';
const abstractions = require('./abstractions');
const getCatalogIds = abstractions.getCatalogIds;
const getCatalogsNames = abstractions.getCatalogsNames;
const mergeData = abstractions.mergeData;
const mergeCodesIds = abstractions.mergeCodesIds;
const mergeCodes = abstractions.mergeCodes;
/**
 * [codeMapping Merge data request with data response from kernel]
 * @return {Object}
 */
exports.codeMapping = function codeMapping(req, res, next) {
  const body = req.body;
  const sections = body.section;
  const codes = body.data;
  // const tenantName = req.tenant;
  // const kernelIp = req.user.tenant.kernel_ip;
  // HF: wait all tenants an kernel envs have funtionality
  const kernelIp = 'dev2.kernel.intelisis.co';
  const tenantName = 'dev2';
  const catalogs = getCatalogsNames(sections);
  const columns = mergeCodes(catalogs, codes);
  const data = {
    tenant_id: tenantName,
    columns,
  };
  // console.log(JSON.stringify(data, null, 2));
  getCatalogIds({ kernelIp, data })
  .then(resultIds => {
    const mergeResult = mergeData(resultIds, codes);
    // const result = mergeCodesIds(mergeResult, codes);
    res.send(mergeResult);
  }).catch(err => {
    next(err);
  });
};
