const Inbox = require('@intelisis/g4-runtime-api-inbox');
const Steps = require('@intelisis/g4-runtime-api-steps');
const db = require('../../database/mongo.js');
const Process = require('@intelisis/g4-process');
const AWSSDK = require('aws-sdk');
const AWS = new AWSSDK.S3(__config.aws);

exports.accesses = function accesses(socket, io, packet) {
  const tenant = socket.get('tenant');
  const tenantName = tenant;
  const processId = packet.processId;
  // Get BappId and diagramId
  const proc = new Process({ _id: processId }, { tenant, db, socket, AWS, io });
  proc.fetch({ trigger: false }).then(() => {
    // const documents = proc.get('documents');
    const bappId = proc.get('bappId');
    const diagramId = proc.get('diagram')._id;
    // Get all positions
    const step = new Steps({ db, tenantName: tenant });
    const modelStep = step.steps;
    return modelStep.find({
      'position.bappId': bappId,
      'position.diagramId': diagramId,
    }).lean()
    .execute((err, results) => {
      // console.log(results);
      socket.emit('inbox:access', { bappId, diagramId });
    });
  });

  // step.fetch().then((err, results) => {
  //   res.send(results);
  // });
};
