const Inbox = require('@intelisis/g4-runtime-api-inbox');
const db = require('../../database/mongo.js');
const dataSchema = require('../../database/schemas/data');
const f = require('./functions.js');

module.exports = (app) => {
  // http routes
  app.get('/inbox', (req, res, next) => {
    next(new Error('test'));
  });
  // socket routes
  return (socket, io) => {
    socket.on('inbox:access', f.accesses.bind({}, socket, io));

    socket.on('inbox:fetch', () => {
      const tenantName = socket.get('tenant');
      const inbox = new Inbox({ db, tenantName });
      const recipient = socket.get('_id');

      inbox.getActive({ recipient }).then((docs) => {

        socket.emit('inbox:fetch', docs);
      }).catch((err) => {
        socket.error(err);
      });
    });

    socket.on('inbox:archive', (inboxId) => {
      const tenantName = socket.get('tenant');
      const socketId = socket.get('_id');
      const inbox = new Inbox({ db, tenantName });
      io.to(socketId).emit('inbox:archive', inboxId);
      inbox.archiveOne(inboxId).catch((err) => {
        socket.error(err);
      });
    });

    socket.on('inbox:save', (pkg) => {
      const tenantName = socket.get('tenant');
      const tenant = db.useDb(tenantName);
      const model = tenant.model('data', dataSchema);
      const inboxId = pkg.inboxId;
      const data = pkg.data;

      // try for mem red.
      tenant.base.connections[0].close();

      model.update({ inboxId }, { data }, { upsert: true }).then(() => {
        //
      }).catch((err) => {
        socket.error(err);
      });
    });
  };
};
