'use strict';
const abstractions = require('./abstractions');
const find = abstractions.find;
/**
 * [getListsByName: get all lists and list by name]
 */
exports.listsByName = (req, res, next) => {
  const tenantName = req.user.tenant.database;
  const urlQuery = req.query;
  let query = undefined;
  if (urlQuery.lists) {
    const lists = urlQuery.lists.split(',');
    query = { name: { $in: lists } };
  }
  find(query, tenantName)
  .then((result) => {
    res.send(result);
  })
  .catch((err) => {
    next(err);
  });
};

/**
 * [showLists: Get all lists]
 */
exports.showLists = function showLists(socket) {
  const tenantName = socket.get('tenant');
  find(null, tenantName)
  .then((result) => {
    socket.emit('lists:show', result);
  })
  .catch((err) => {
    socket.error(err);
  });
};
