const f = require('./functions.js');

module.exports = (app, protect) => {
  app.get('/metadata', protect, f.getMetadataList);
  // Uncoment it when all is ready to grant access (XHR)
  app.get('/business_apps', protect, f.getBusinessAppsListHTTP_access);
  // app.get('/business_apps', protect, f.getBusinessAppsListHTTP);
  app.get('/security/business_apps', protect, f.getBusinessAppsListHTTP);
  app.get('/business_apps/:_id/diagram/:diagram_id', protect, f.getDiagram);

  return (socket, io) => {
    socket.on('process:start', f.startProcess.bind({}, socket, io));
    // Uncoment it when all is ready to grant access (SOCKET)
    socket.on('business_apps:list', f.getBusinessAppsListWS_access.bind({}, socket, io));
    // socket.on('business_apps:list', f.getBusinessAppsListWS.bind({}, socket, io));
    socket.on('business_apps:security', f.getBusinessAppsListWS.bind({}, socket, io));
  };
};
