const NODE_ENV = process.env.NODE_ENV || 'local';

const walk = require('fs-walk');
const yaml = require('js-yaml');
const fs = require('fs');

const config = {};
const path = `${__dirname}/${NODE_ENV}`;
const pkgFile = `${process.cwd()}/package.json`;
const pkg = fs.readFileSync(pkgFile);

walk.walkSync(path, (basedir, filename) => {
  const section = filename.split('.')[0];
  const absoluteFilename = `${path}/${filename}`;
  const doc = yaml.safeLoad(fs.readFileSync(absoluteFilename, 'utf-8'));

  if (doc) {
    config[section] = doc;
  }
});

config.version = JSON.parse(pkg).version;

global.__config = config;
global.dependencies = {};
